--- rc.S	2005-08-04 21:29:07.000000000 +0200
+++ rc.S	2007-07-09 20:14:44.000000000 +0200
@@ -35,13 +35,6 @@
   fi
 fi
 
-# Initialize udev to manage /dev entries for 2.6.x kernels:
-if [ -x /etc/rc.d/rc.udev ]; then
-  if ! grep -w nohotplug /proc/cmdline 1> /dev/null 2> /dev/null ; then
-    /etc/rc.d/rc.udev
-  fi
-fi
-
 # Enable swapping:
 /sbin/swapon -a
 
@@ -172,6 +165,16 @@
   /sbin/mount -f sysfs /sys -t sysfs
 fi
 
+# Initialize udev to manage /dev entries for 2.6.x kernels:
+if cat /proc/mounts | grep -wq sysfs && cat /proc/filesystems | grep -wq tmpfs ; then
+  if ! grep -wq nohotplug /proc/cmdline ; then
+    if [ -x /etc/rc.d/rc.udev ]; then
+      /bin/sh /etc/rc.d/rc.udev start
+      /bin/sh /lib/udev/udev.count_events.sh
+    fi
+  fi
+fi
+
 # Set the system time from the hardware clock using hwclock --hctosys.
 if [ -x /sbin/hwclock ]; then
   # Check for a broken motherboard RTC clock (where ioports for rtc are
